/*
 * addContract.java
 *
 * Created on February 23, 2007, 11:47 AM
 *
 * By: Chace L. Prochazka
 */

package javaapplication3;
import java.awt.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author  hp
 */
public class addContract extends javax.swing.JFrame {
    DefaultListModel theSkills = new DefaultListModel();
    
    public Vector GetClients() {
        Vector companyNames = new Vector();
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            
            String sql = "SELECT ID, CompanyName FROM Company";
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    companyNames.addElement(rs.getObject(1) + " - " + rs.getObject(2));
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return companyNames;
        
}
    
        public void AddContract() {
        
        //   Populate variables
        
        int id = cboClients.getSelectedIndex();
        String clientid = cboClients.getItemAt(id).toString();
        int thePlace = clientid.indexOf("-");
        String theid = clientid.substring(0,(thePlace - 1));
        int sid = Integer.valueOf(theid);
        String city = txtCity.getText();
        String state = txtState.getText();
        String zipcode = txtZip.getText();
        String length = txtJobLength.getText();
        String start = txtStartDate.getText();
        String end = txtEndDate.getText();
        String payrate = txtPayRate.getText();
        
        String skillString = "";
        for (int i=0; i<theSkills.getSize(); i++) { 
            if (i==(theSkills.getSize()-1)) {
                skillString = skillString + theSkills.getElementAt(i);
            } else {
                skillString = skillString + theSkills.getElementAt(i) + ",";
            }
        }
        
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Send insert to table
 
            String sql = "INSERT INTO Contracts (CompID, City, State, ZipCode, Length, StartDate, EndDate, PayRate, JobDesc) VALUES (" + sid + ", '" + city + "', '" + state + "', '" + zipcode + "', '" + length + "', '" + start + "', '" + end + "', '" + payrate + "', '" + skillString + "')";
            Statement stmt = connection.createStatement();
            stmt.executeQuery( sql );
 
            stmt.close();
            
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
    }
    
    /** Creates new form addContract */
    public addContract() {
        initComponents();
        setLocationRelativeTo(null);
        DefaultComboBoxModel model = new DefaultComboBoxModel(GetClients());
        cboClients.setModel(model); 
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        cboClients = new javax.swing.JComboBox();
        txtCity = new javax.swing.JTextField();
        txtState = new javax.swing.JTextField();
        txtZip = new javax.swing.JTextField();
        txtJobLength = new javax.swing.JTextField();
        txtStartDate = new javax.swing.JTextField();
        txtEndDate = new javax.swing.JTextField();
        txtPayRate = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstJobSkills = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        txtJobSkill = new javax.swing.JTextField();
        btnRemoveJobSkill = new javax.swing.JButton();
        btnAddJobSkill = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        btnAddContract = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Add Contract");
        setResizable(false);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jScrollPane1.setViewportView(lstJobSkills);

        jLabel1.setText("Job Skills Needed:");

        btnRemoveJobSkill.setText("-");
        btnRemoveJobSkill.setToolTipText("Click to take selected Job Skill off list");
        btnRemoveJobSkill.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnRemoveJobSkill.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnRemoveJobSkillMouseClicked(evt);
            }
        });

        btnAddJobSkill.setText("+");
        btnAddJobSkill.setToolTipText("Click to add Job Skill to list of requirements");
        btnAddJobSkill.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddJobSkill.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnAddJobSkillMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 182, Short.MAX_VALUE)
                    .add(jLabel1)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(txtJobSkill, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 134, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnAddJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnRemoveJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(8, 8, 8)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnRemoveJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnAddJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(txtJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel2.setText("Company");

        jLabel3.setText("City");

        jLabel4.setText("State");

        jLabel5.setText("Zip Code");

        jLabel6.setText("Job Length (days)");

        jLabel7.setText("Starting Date");

        jLabel8.setText("Ending Date");

        jLabel9.setText("Pay Rate");

        btnAddContract.setText("Add");
        btnAddContract.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnAddContractMouseClicked(evt);
            }
        });

        btnCancel.setText("Cancel");
        btnCancel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnCancelMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jLabel2)
                            .add(jLabel3)
                            .add(jLabel4)
                            .add(jLabel5)
                            .add(jLabel6)
                            .add(jLabel7)
                            .add(jLabel8)
                            .add(jLabel9))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtPayRate)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, cboClients, 0, 102, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtCity)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtState, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 131, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtZip)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtJobLength)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtStartDate)
                            .add(txtEndDate))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(btnAddContract)
                        .add(42, 42, 42)))
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(btnCancel)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(cboClients, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel2))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(txtCity, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel3))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(txtState, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel4))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(txtZip, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel5))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(txtJobLength, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel6))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(txtStartDate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel7))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel8)
                            .add(txtEndDate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(txtPayRate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel9)))
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(17, 17, 17)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnCancel)
                    .add(btnAddContract))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnAddContractMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAddContractMouseClicked
        AddContract();
        this.dispose();
    }//GEN-LAST:event_btnAddContractMouseClicked

    private void btnRemoveJobSkillMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnRemoveJobSkillMouseClicked
        theSkills.remove(lstJobSkills.getSelectedIndex());
        lstJobSkills.setModel(theSkills);
    }//GEN-LAST:event_btnRemoveJobSkillMouseClicked

    private void btnCancelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnCancelMouseClicked
        this.dispose();
    }//GEN-LAST:event_btnCancelMouseClicked

    private void btnAddJobSkillMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAddJobSkillMouseClicked
        theSkills.addElement(txtJobSkill.getText());
        lstJobSkills.setModel(theSkills);
        txtJobSkill.setText(null);
    }//GEN-LAST:event_btnAddJobSkillMouseClicked

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
       
    }//GEN-LAST:event_formMouseClicked
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new addContract().setVisible(true);
                
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddContract;
    private javax.swing.JButton btnAddJobSkill;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnRemoveJobSkill;
    private javax.swing.JComboBox cboClients;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList lstJobSkills;
    private javax.swing.JTextField txtCity;
    private javax.swing.JTextField txtEndDate;
    private javax.swing.JTextField txtJobLength;
    private javax.swing.JTextField txtJobSkill;
    private javax.swing.JTextField txtPayRate;
    private javax.swing.JTextField txtStartDate;
    private javax.swing.JTextField txtState;
    private javax.swing.JTextField txtZip;
    // End of variables declaration//GEN-END:variables
    
}
