/*
 * NewJFrame.java
 *
 * Created on February 11, 2007, 5:54 PM
 *
 * By: Chace L. Prochazka
 */

package javaapplication3;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import java.awt.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;



public class NewJFrame extends javax.swing.JFrame {
    
    /** Creates new form NewJFrame */
    public NewJFrame() {
        initComponents();
        setLocationRelativeTo(null);
    }
    //   Populates a Vector with the Contract records that are unfilled
     public Vector GetOpenContracts() {
        Vector contracts = new Vector();
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            String sql = "SELECT Contracts.ID, Contracts.CompID, Company.CompanyName FROM Contracts, Company WHERE Contracts.CompID = Company.ID AND Contracts.Filled = FALSE";
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    contracts.addElement(rs.getObject(1) + " - " + rs.getObject(2) + " - " + rs.getObject(3));
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return contracts;
}
     
    //   Populates a Vector with the Contract records that are filled
     public Vector GetFilledContracts() {
        Vector filledcontracts = new Vector();
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            String sql = "SELECT Contracts.ID, Contracts.CompID, Contracts.EmpID, Company.CompanyName, Company.ID, Employee.ID, Employee.FirstName, Employee.LastName FROM Contracts, Company, Employee WHERE Contracts.EmpID = Employee.ID AND Contracts.Filled = TRUE AND Contracts.CompID = Company.ID" ;
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    filledcontracts.addElement(rs.getObject(1) + " - " + rs.getObject(4) + "(" + rs.getObject(2) + ")" + " CONTRACTED: " + rs.getObject(7) + " " + rs.getObject(8) + "(" + rs.getObject(6) + ")");
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return filledcontracts;
}
     
    //   Forms a String delimeted by commas of the job skills required by the Contract
     public String GetRequiredSkills(int ID) {
        String jobSkills = "";
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            String sql = "SELECT JobDesc FROM Contracts WHERE ID = " + ID;
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    jobSkills = rs.getObject(1).toString();
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return jobSkills;
}
     
    //   Forms a String delimeted by commas of the job skills an employee has
     public String GetEmployeeSkills(int ID) {
        String jobSkills = "";
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            String sql = "SELECT JobSkills FROM Employee WHERE ID = " + ID;
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    jobSkills = rs.getObject(1).toString();
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return jobSkills;
}

    //   Loops through all employees to find matching Job Skills, with the Job Requirements
     public void GenerateEmployees(String JobReq) {
        DefaultListModel matchSkills = new DefaultListModel();
        
        //   Break string into array
        
    int idx = 0; 
    int tokenCount;
    String words[] = new String [500];
    StringTokenizer st = new StringTokenizer(JobReq,",");
    tokenCount = st.countTokens();
    while (st.hasMoreTokens())
        { 
            words[idx] = st.nextToken();
            idx++;
        }
 
        try
        {
            
            //  Connect to the Database
            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            String sql = "SELECT ID, FirstName, LastName, JobSkills FROM Employee";
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
                
            
            //   Loop through all records ** This is the MEAT **

            while (rs.next()) {
                    int idz = 0;
                    int hitCount = 0;
                    int tokenCountz;
                    String moreSkills = rs.getObject(4).toString();
                    String wordsz[] = new String [500];
                    StringTokenizer stz = new StringTokenizer(moreSkills,",");
                    tokenCountz = stz.countTokens();
                    while (stz.hasMoreTokens())
                        { 
                           wordsz[idz] = stz.nextToken();
                           for (int j=0; j<tokenCount; j++) {
                                if (words[j].equalsIgnoreCase(wordsz[idz]) == true) {
                                    hitCount++;
                                }
                           }
                        }
                               if (hitCount == 1) {
                               matchSkills.addElement(rs.getObject(1) + " - " + rs.getObject(2) + " " + rs.getObject(3));
                                } else if (hitCount > 1) {
                               matchSkills.addElement(rs.getObject(1) + " - " + rs.getObject(2) + " " + rs.getObject(3) + "(" + hitCount + ")");
                                }
            }
                    lstMatches.setModel(matchSkills);
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            System.out.println( e );
        }
        
        //return contracts;
}
    
    //   Marks a Contract to filled
     public void MarkContractFilled(int ContractID) {
        
        try {
            //  Connect to the Database
            
            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
            
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
            
            //  Send update to table
            
            String sql = "UPDATE Contracts SET Filled = true WHERE ID = " + ContractID;
            Statement stmt = connection.createStatement();
            stmt.executeQuery( sql );
            
            stmt.close();
        } catch(Exception e) {
            //System.out.println( e );
        }
    }
     
         public String GetAValue(int ID, String tableName, String columnName) {
        String retVal = "";
        
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
            
            
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            String sql = "SELECT " + columnName + " FROM " + tableName + " WHERE ID = " + ID;
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    retVal = rs.getObject(1).toString();
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return retVal;
}
    
    //   Assigns an Employee's ID to the Contract
     public void AssignEmployee(int EmpID, int ContID) {
        
        try {
            //  Connect to the Database
            
            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
            
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
            
            //  Send update to table
            
            String sql = "UPDATE Contracts SET EmpID = " + EmpID + " WHERE ID = " + ContID;
            Statement stmt = connection.createStatement();
            stmt.executeQuery( sql );
            
            stmt.close();
        } catch(Exception e) {
            //System.out.println( e );
        }
   }
    
    //   Marks a Contract unfilled
     public void MarkContractUnfilled(int ContractID) {
        
        try {
            //  Connect to the Database
            
            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
            
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
            
            //  Send update to table
            
            String sql = "UPDATE Contracts SET Filled = false WHERE ID = " + ContractID;
            Statement stmt = connection.createStatement();
            stmt.executeQuery( sql );
            
            stmt.close();
        } catch(Exception e) {
            //System.out.println( e );
        }
    }
     
 public void ClearEmpOnContract(int ContractID) {
        
        try {
            //  Connect to the Database
            
            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
            
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
            
            //  Send update to table
            
            String sql = "UPDATE Contracts SET EmpID = null WHERE ID = " + ContractID;
            Statement stmt = connection.createStatement();
            stmt.executeQuery( sql );
            
            stmt.close();
        } catch(Exception e) {
            //System.out.println( e );
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel3 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        lstJobSkills = new javax.swing.JList();
        jLabel11 = new javax.swing.JLabel();
        txtJobSkill = new javax.swing.JTextField();
        btnRemoveJobSkill = new javax.swing.JButton();
        btnAddJobSkill = new javax.swing.JButton();
        tbdMain = new javax.swing.JTabbedPane();
        pnlLogin = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        cboLogin = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        btnLogin = new javax.swing.JButton();
        btnLogout = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        txtPwd = new javax.swing.JPasswordField();
        pnlPlacement = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstContracts = new javax.swing.JList();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstMatches = new javax.swing.JList();
        jPanel9 = new javax.swing.JPanel();
        txtContractSkills = new javax.swing.JTextArea();
        jPanel8 = new javax.swing.JPanel();
        txtEmployeeSkills = new javax.swing.JTextArea();
        btnGenerate = new javax.swing.JButton();
        btnFillRequest = new javax.swing.JButton();
        pnlArrangements = new javax.swing.JPanel();
        btnGenMemo = new javax.swing.JButton();
        jBtnNewEmp = new javax.swing.JButton();
        jPanel10 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        lstFilledContracts = new javax.swing.JList();
        btnReFillContract = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        pnlContracts = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jButton5 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        btnViewOpenContracts = new javax.swing.JButton();
        jPanel11 = new javax.swing.JPanel();
        jButton6 = new javax.swing.JButton();
        btnAddClient = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jToolBar2 = new javax.swing.JToolBar();
        lblInformer = new javax.swing.JLabel();

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jScrollPane3.setViewportView(lstJobSkills);

        jLabel11.setText("Job Skills Needed:");

        btnRemoveJobSkill.setText("-");
        btnRemoveJobSkill.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnRemoveJobSkill.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnRemoveJobSkillMouseClicked(evt);
            }
        });

        btnAddJobSkill.setText("+");
        btnAddJobSkill.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddJobSkill.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnAddJobSkillMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 182, Short.MAX_VALUE)
                    .add(jLabel11)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                        .add(txtJobSkill, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 134, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnAddJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnRemoveJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(8, 8, 8)
                .add(jLabel11)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnRemoveJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnAddJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(txtJobSkill, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("GC Concepts Contract Automation");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        tbdMain.setFont(new java.awt.Font("Tahoma", 0, 12));
        tbdMain.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                tbdMainFocusGained(evt);
            }
        });

        jLabel1.setText("Password");

        cboLogin.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Contract Manager", "Placement", "Arrangements", "Administration" }));

        jLabel2.setText("Choose login privileges");

        btnLogin.setText("Login");
        btnLogin.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnLoginMouseClicked(evt);
            }
        });

        btnLogout.setText("Log Out");
        btnLogout.setEnabled(false);
        btnLogout.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnLogoutMouseClicked(evt);
            }
        });

        jLabel4.setIcon(new javax.swing.ImageIcon("C:\\splash.png"));

        org.jdesktop.layout.GroupLayout pnlLoginLayout = new org.jdesktop.layout.GroupLayout(pnlLogin);
        pnlLogin.setLayout(pnlLoginLayout);
        pnlLoginLayout.setHorizontalGroup(
            pnlLoginLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pnlLoginLayout.createSequentialGroup()
                .add(107, 107, 107)
                .add(pnlLoginLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jLabel2)
                    .add(jLabel1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(pnlLoginLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(cboLogin, 0, 185, Short.MAX_VALUE)
                    .add(pnlLoginLayout.createSequentialGroup()
                        .add(btnLogin)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnLogout))
                    .add(txtPwd))
                .addContainerGap(130, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, pnlLoginLayout.createSequentialGroup()
                .addContainerGap(57, Short.MAX_VALUE)
                .add(jLabel4)
                .add(49, 49, 49))
        );
        pnlLoginLayout.setVerticalGroup(
            pnlLoginLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, pnlLoginLayout.createSequentialGroup()
                .add(26, 26, 26)
                .add(jLabel4)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 32, Short.MAX_VALUE)
                .add(pnlLoginLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cboLogin, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel2))
                .add(16, 16, 16)
                .add(pnlLoginLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(txtPwd, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(26, 26, 26)
                .add(pnlLoginLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnLogin)
                    .add(btnLogout))
                .add(42, 42, 42))
        );
        tbdMain.addTab("Login / Logout", pnlLogin);

        pnlPlacement.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                pnlPlacementFocusGained(evt);
            }
        });

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Staff Requests/Contracts:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 0)));
        lstContracts.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lstContractsMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(lstContracts);

        org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 184, Short.MAX_VALUE)
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
        );

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Possible Staff/Employees:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 0)));
        lstMatches.setEnabled(false);
        lstMatches.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lstMatchesMouseClicked(evt);
            }
        });

        jScrollPane2.setViewportView(lstMatches);

        org.jdesktop.layout.GroupLayout jPanel7Layout = new org.jdesktop.layout.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 161, Short.MAX_VALUE)
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
        );

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("Job Skills Needed:"));
        txtContractSkills.setBackground(javax.swing.UIManager.getDefaults().getColor("Panel.background"));
        txtContractSkills.setColumns(20);
        txtContractSkills.setEditable(false);
        txtContractSkills.setFont(new java.awt.Font("Tahoma", 0, 11));
        txtContractSkills.setLineWrap(true);
        txtContractSkills.setRows(5);
        txtContractSkills.setWrapStyleWord(true);
        txtContractSkills.setBorder(null);
        txtContractSkills.setFocusable(false);
        txtContractSkills.setMargin(new java.awt.Insets(1, 1, 1, 1));
        txtContractSkills.setSelectionColor(javax.swing.UIManager.getDefaults().getColor("Panel.background"));

        org.jdesktop.layout.GroupLayout jPanel9Layout = new org.jdesktop.layout.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(txtContractSkills, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 110, Short.MAX_VALUE)
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(txtContractSkills, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
        );

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("Employee Skills:")));
        txtEmployeeSkills.setBackground(javax.swing.UIManager.getDefaults().getColor("Panel.background"));
        txtEmployeeSkills.setColumns(20);
        txtEmployeeSkills.setEditable(false);
        txtEmployeeSkills.setFont(new java.awt.Font("Tahoma", 0, 11));
        txtEmployeeSkills.setLineWrap(true);
        txtEmployeeSkills.setRows(5);
        txtEmployeeSkills.setWrapStyleWord(true);
        txtEmployeeSkills.setBorder(null);
        txtEmployeeSkills.setFocusable(false);
        txtEmployeeSkills.setMargin(new java.awt.Insets(1, 1, 1, 1));
        txtEmployeeSkills.setSelectionColor(javax.swing.UIManager.getDefaults().getColor("Panel.background"));

        org.jdesktop.layout.GroupLayout jPanel8Layout = new org.jdesktop.layout.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(txtEmployeeSkills, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 102, Short.MAX_VALUE)
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(txtEmployeeSkills, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 108, Short.MAX_VALUE)
        );

        btnGenerate.setText("Generate Matches");
        btnGenerate.setEnabled(false);
        btnGenerate.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnGenerateMouseClicked(evt);
            }
        });

        btnFillRequest.setText("Assign to Contract");
        btnFillRequest.setEnabled(false);
        btnFillRequest.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnFillRequestMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout pnlPlacementLayout = new org.jdesktop.layout.GroupLayout(pnlPlacement);
        pnlPlacement.setLayout(pnlPlacementLayout);
        pnlPlacementLayout.setHorizontalGroup(
            pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pnlPlacementLayout.createSequentialGroup()
                .add(pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(pnlPlacementLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(jPanel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(pnlPlacementLayout.createSequentialGroup()
                        .add(43, 43, 43)
                        .add(btnGenerate)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jPanel9, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(pnlPlacementLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(pnlPlacementLayout.createSequentialGroup()
                        .add(40, 40, 40)
                        .add(btnFillRequest)))
                .addContainerGap())
        );
        pnlPlacementLayout.setVerticalGroup(
            pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pnlPlacementLayout.createSequentialGroup()
                .addContainerGap()
                .add(pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(pnlPlacementLayout.createSequentialGroup()
                        .add(pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jPanel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(pnlPlacementLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(btnFillRequest)
                            .add(btnGenerate)))
                    .add(pnlPlacementLayout.createSequentialGroup()
                        .add(jPanel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        tbdMain.addTab(" Placement", pnlPlacement);

        btnGenMemo.setText("Generate Memo");
        btnGenMemo.setEnabled(false);
        btnGenMemo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnGenMemoMouseClicked(evt);
            }
        });

        jBtnNewEmp.setMnemonic('E');
        jBtnNewEmp.setText("New Employee");
        jBtnNewEmp.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jBtnNewEmpMouseClicked(evt);
            }
        });

        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Filled Contracts:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 0)));
        lstFilledContracts.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lstFilledContractsMouseClicked(evt);
            }
        });

        jScrollPane4.setViewportView(lstFilledContracts);

        org.jdesktop.layout.GroupLayout jPanel10Layout = new org.jdesktop.layout.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 322, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 238, Short.MAX_VALUE)
                .addContainerGap())
        );

        btnReFillContract.setText("Cancel & Re-Fill Contract");
        btnReFillContract.setEnabled(false);
        btnReFillContract.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnReFillContractMouseClicked(evt);
            }
        });

        jButton8.setText("Modify Employee");
        jButton8.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton8MouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout pnlArrangementsLayout = new org.jdesktop.layout.GroupLayout(pnlArrangements);
        pnlArrangements.setLayout(pnlArrangementsLayout);
        pnlArrangementsLayout.setHorizontalGroup(
            pnlArrangementsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, pnlArrangementsLayout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel10, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(pnlArrangementsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jBtnNewEmp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                    .add(jButton8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                    .add(btnGenMemo, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                    .add(btnReFillContract, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        pnlArrangementsLayout.setVerticalGroup(
            pnlArrangementsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pnlArrangementsLayout.createSequentialGroup()
                .addContainerGap()
                .add(pnlArrangementsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel10, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(pnlArrangementsLayout.createSequentialGroup()
                        .add(38, 38, 38)
                        .add(jBtnNewEmp)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton8)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnGenMemo)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnReFillContract)))
                .addContainerGap())
        );
        tbdMain.addTab("Arrangements", pnlArrangements);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Update Records:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 0)));
        jButton7.setText("Modify Staff");
        jButton7.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton7MouseClicked(evt);
            }
        });

        jButton2.setText("Modify Client");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2MouseClicked(evt);
            }
        });

        jButton4.setMnemonic('M');
        jButton4.setText("Modify Contract");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton4MouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jButton4))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jButton4)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton7)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("View Records:"));
        jButton5.setText("View All Staff");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton5MouseClicked(evt);
            }
        });

        jButton1.setText("View All Clients");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1MouseClicked(evt);
            }
        });

        btnViewOpenContracts.setText("View All Contracts");
        btnViewOpenContracts.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnViewOpenContractsMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(btnViewOpenContracts, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                    .add(jButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jButton5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(btnViewOpenContracts)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton5)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Add Records:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(204, 0, 51)));
        jButton6.setText("Add Staff");
        jButton6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton6MouseClicked(evt);
            }
        });

        btnAddClient.setText("Add Client");
        btnAddClient.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnAddClientMouseClicked(evt);
            }
        });

        jButton3.setText("Add Contract");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton3MouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel11Layout = new org.jdesktop.layout.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jButton6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jButton3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnAddClient, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .add(jButton3)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnAddClient)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton6)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout pnlContractsLayout = new org.jdesktop.layout.GroupLayout(pnlContracts);
        pnlContracts.setLayout(pnlContractsLayout);
        pnlContractsLayout.setHorizontalGroup(
            pnlContractsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, pnlContractsLayout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(28, 28, 28)
                .add(jPanel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(25, 25, 25)
                .add(jPanel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(25, 25, 25))
        );
        pnlContractsLayout.setVerticalGroup(
            pnlContractsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(pnlContractsLayout.createSequentialGroup()
                .add(48, 48, 48)
                .add(pnlContractsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel11, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(120, Short.MAX_VALUE))
        );
        tbdMain.addTab("Contract Manager", pnlContracts);

        getContentPane().add(tbdMain, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 540, 330));

        jToolBar2.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        lblInformer.setText("Status...");
        jToolBar2.add(lblInformer);

        getContentPane().add(jToolBar2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 330, 540, 20));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton8MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton8MouseClicked
        new getID("staff").setVisible(true);
        lblInformer.setText("Modifying record...");
    }//GEN-LAST:event_jButton8MouseClicked

    private void jButton5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton5MouseClicked

        new TableFromDatabase("Employee").setVisible(true);
        lblInformer.setText("Viewing Employee Database...");
    }//GEN-LAST:event_jButton5MouseClicked

    private void jButton1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseClicked

        new TableFromDatabase("Company").setVisible(true);
        lblInformer.setText("Viewing Company Database...");
    }//GEN-LAST:event_jButton1MouseClicked

    private void jButton6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton6MouseClicked
        new addStaff().setVisible(true);
        lblInformer.setText("Adding staff record...");
    }//GEN-LAST:event_jButton6MouseClicked

    private void jButton2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2MouseClicked
        new getID("client").setVisible(true);
        lblInformer.setText("Modifying record...");
    }//GEN-LAST:event_jButton2MouseClicked

    private void jButton4MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton4MouseClicked
        new getID("contract").setVisible(true);
        lblInformer.setText("Modifying record...");
    }//GEN-LAST:event_jButton4MouseClicked

    private void jButton7MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton7MouseClicked
        new getID("staff").setVisible(true);
        lblInformer.setText("Modifying record...");
    }//GEN-LAST:event_jButton7MouseClicked

    private void btnGenMemoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnGenMemoMouseClicked
        if (btnGenMemo.isEnabled() == true) {
            lblInformer.setText("Generating Memo...");
            String hVal = lstFilledContracts.getSelectedValue().toString();
            int count = hVal.indexOf("-");
            String jVal = hVal.substring(0,(count-1));
            int theID = Integer.valueOf(jVal);
            new showMemo(theID).setVisible(true);
        }
    }//GEN-LAST:event_btnGenMemoMouseClicked

    private void btnReFillContractMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnReFillContractMouseClicked
           String getID = lstFilledContracts.getSelectedValue().toString();
           int count = getID.indexOf("-");
           String trimString = getID.substring(0,(count-1));
           int actID = Integer.valueOf(trimString);
           MarkContractUnfilled(actID);
           ClearEmpOnContract(actID);
           btnGenMemo.setEnabled(false);
           btnReFillContract.setEnabled(false);
           lblInformer.setText("Contract set to be re-filled...");
    }//GEN-LAST:event_btnReFillContractMouseClicked

    private void lstFilledContractsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lstFilledContractsMouseClicked
        btnGenMemo.setEnabled(true);
        btnReFillContract.setEnabled(true);
    }//GEN-LAST:event_lstFilledContractsMouseClicked

    private void btnFillRequestMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnFillRequestMouseClicked
        if (btnFillRequest.isEnabled() == true) {
        String tempID = lstMatches.getSelectedValue().toString();
        int acount = tempID.indexOf("-");
        String modID = tempID.substring(0,(acount-1));
        int newID = Integer.valueOf(modID);
        String bID = lstContracts.getSelectedValue().toString();
        int bcount = bID.indexOf("-");
        int cID = Integer.valueOf(bID.substring(0,(bcount-1)));
        AssignEmployee(newID,cID);
        MarkContractFilled(cID);
        lblInformer.setText("Contract paired with Employee...");
        DefaultListModel clearSkills = new DefaultListModel();
        clearSkills.clear();
        lstMatches.setModel(clearSkills);
        btnGenerate.setEnabled(true);
        lstMatches.setEnabled(false);
        btnFillRequest.setEnabled(false);
        txtEmployeeSkills.setText("");
        }
    }//GEN-LAST:event_btnFillRequestMouseClicked

    private void lstMatchesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lstMatchesMouseClicked
        if (lstMatches.isEnabled() == true) {
        btnFillRequest.setEnabled(true);
        String theID = lstMatches.getSelectedValue().toString();
        int count = theID.indexOf("-");
        int aID = Integer.valueOf(theID.substring(0,(count-1)));
        txtEmployeeSkills.setText(GetEmployeeSkills(aID));
        }
    }//GEN-LAST:event_lstMatchesMouseClicked

    private void tbdMainFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_tbdMainFocusGained
        DefaultListModel theSkills = new DefaultListModel();
        for (int i=0; i<GetOpenContracts().size(); i++) {
        theSkills.addElement(GetOpenContracts().get(i));
        }
        lstContracts.setModel(theSkills);
   

        DefaultListModel filledContracts = new DefaultListModel();
        for (int b=0; b<GetFilledContracts().size(); b++) {
        filledContracts.addElement(GetFilledContracts().get(b));
        }
        lstFilledContracts.setModel(filledContracts);
    }//GEN-LAST:event_tbdMainFocusGained

    private void btnGenerateMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnGenerateMouseClicked
        lstMatches.setEnabled(true);
        lblInformer.setText("Finding possible Employee matches...");
        String theID = lstContracts.getSelectedValue().toString();
        int dcount = theID.indexOf("-");
        int aID = Integer.valueOf(theID.substring(0,(dcount-1)));
        GenerateEmployees(GetAValue(aID, "Contracts", "JobDesc"));
        lblInformer.setText("Displaying match results...");
    }//GEN-LAST:event_btnGenerateMouseClicked

    private void pnlPlacementFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_pnlPlacementFocusGained
        
    }//GEN-LAST:event_pnlPlacementFocusGained

    private void lstContractsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lstContractsMouseClicked
        DefaultListModel clearSkills = new DefaultListModel();
        clearSkills.clear();
        lstMatches.setModel(clearSkills);
        btnGenerate.setEnabled(true);
        lstMatches.setEnabled(false);
        btnFillRequest.setEnabled(false);
        txtEmployeeSkills.setText("");
        String theID = lstContracts.getSelectedValue().toString();
        int dcount = theID.indexOf("-");
        int aID = Integer.valueOf(theID.substring(0,(dcount-1)));
        txtContractSkills.setText(GetRequiredSkills(aID));
    }//GEN-LAST:event_lstContractsMouseClicked

    private void jButton3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton3MouseClicked
        new addContract().setVisible(true);   
        lblInformer.setText("Adding Contract record...");
    }//GEN-LAST:event_jButton3MouseClicked

    private void btnViewOpenContractsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnViewOpenContractsMouseClicked

        new TableFromDatabase("Contracts").setVisible(true);
        lblInformer.setText("Viewing Contracts Database...");
    }//GEN-LAST:event_btnViewOpenContractsMouseClicked

    private void btnAddClientMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAddClientMouseClicked
        new addClient().setVisible(true);
        lblInformer.setText("Adding Client record...");
    }//GEN-LAST:event_btnAddClientMouseClicked

    private void btnAddJobSkillMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnAddJobSkillMouseClicked



    }//GEN-LAST:event_btnAddJobSkillMouseClicked

    private void btnRemoveJobSkillMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnRemoveJobSkillMouseClicked

    }//GEN-LAST:event_btnRemoveJobSkillMouseClicked

    private void jBtnNewEmpMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jBtnNewEmpMouseClicked
        new addStaff().setVisible(true);
    }//GEN-LAST:event_jBtnNewEmpMouseClicked
                                        
    private void btnLoginMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnLoginMouseClicked
        if (cboLogin.getSelectedItem().toString().equalsIgnoreCase("Administration")) {
            if (String.valueOf(txtPwd.getPassword()).equalsIgnoreCase("password")) {
                lblInformer.setText("Logging in...");
                tbdMain.setSelectedIndex(3);
                tbdMain.setEnabledAt(0,true);
                tbdMain.setEnabledAt(1,true);
                tbdMain.setEnabledAt(2,true);
                tbdMain.setEnabledAt(3, true);
                cboLogin.setEnabled(false);
                txtPwd.setText("");
                txtPwd.setEnabled(false);
                btnLogin.setEnabled(false);
                btnLogout.setEnabled(true);
                lblInformer.setText("Sucessfully logged in as an Administrator");
            }
        }
        if (cboLogin.getSelectedItem().toString().equalsIgnoreCase("Arrangements")) {
            if (String.valueOf(txtPwd.getPassword()).equalsIgnoreCase("password")) {
                lblInformer.setText("Logging in...");
                tbdMain.setSelectedIndex(2);
                tbdMain.setEnabledAt(2,true);
                cboLogin.setEnabled(false);
                txtPwd.setEnabled(false);
                txtPwd.setText("");
                btnLogin.setEnabled(false);
                btnLogout.setEnabled(true);
                lblInformer.setText("Sucessfully logged in as Arrangements officer");
            }
        }
        if (cboLogin.getSelectedItem().toString().equalsIgnoreCase("Placement")) {
            if (String.valueOf(txtPwd.getPassword()).equalsIgnoreCase("password")) {
                lblInformer.setText("Logging in...");
                tbdMain.setSelectedIndex(1);
                tbdMain.setEnabledAt(1,true);
                tbdMain.setEnabledAt(2,false);
                tbdMain.setEnabledAt(3,false);
                cboLogin.setEnabled(false);
                txtPwd.setEnabled(false);
                txtPwd.setText("");
                btnLogin.setEnabled(false);
                btnLogout.setEnabled(true);
                lblInformer.setText("Sucessfully logged in as Placement officer");
            }
        }
        if (cboLogin.getSelectedItem().toString().equalsIgnoreCase("Contract Manager")) {
            if (String.valueOf(txtPwd.getPassword()).equalsIgnoreCase("password")) {
                lblInformer.setText("Logging in...");
                tbdMain.setSelectedIndex(3);
                tbdMain.setEnabledAt(2,false);
                tbdMain.setEnabledAt(3,true);
                tbdMain.setEnabledAt(1,false);
                cboLogin.setEnabled(false);
                txtPwd.setEnabled(false);
                txtPwd.setText("");
                btnLogin.setEnabled(false);
                btnLogout.setEnabled(true);
                lblInformer.setText("Sucessfully logged in as Contract Manager");
            }
        }
    }//GEN-LAST:event_btnLoginMouseClicked
    
    private void btnLogoutMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnLogoutMouseClicked
        lblInformer.setText("Logging out...");
        tbdMain.setSelectedIndex(0);
        tbdMain.setEnabledAt(3,false);
        tbdMain.setEnabledAt(2,false);
        tbdMain.setEnabledAt(1,false);
        cboLogin.setEnabled(true);
        txtPwd.setEnabled(true);
        btnLogin.setEnabled(true);
        btnLogout.setEnabled(false);
        lblInformer.setText("Sucessfully logged out");
    }//GEN-LAST:event_btnLogoutMouseClicked
    
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        
        tbdMain.setEnabledAt(0,true);
        tbdMain.setEnabledAt(1,false);
        tbdMain.setEnabledAt(2,false);
        tbdMain.setEnabledAt(3,false);
    }//GEN-LAST:event_formWindowOpened
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                
                try {
                    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                } catch (UnsupportedLookAndFeelException e) {
                    // handle
                } catch (ClassNotFoundException e) {
                    // handle
                } catch (InstantiationException e) {
                    // handle
                } catch (IllegalAccessException e) {
                    // handle
                }
                
                new NewJFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddClient;
    private javax.swing.JButton btnAddJobSkill;
    private javax.swing.JButton btnFillRequest;
    private javax.swing.JButton btnGenMemo;
    private javax.swing.JButton btnGenerate;
    private javax.swing.JButton btnLogin;
    private javax.swing.JButton btnLogout;
    private javax.swing.JButton btnReFillContract;
    private javax.swing.JButton btnRemoveJobSkill;
    private javax.swing.JButton btnViewOpenContracts;
    private javax.swing.JComboBox cboLogin;
    private javax.swing.JButton jBtnNewEmp;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JToolBar jToolBar2;
    private javax.swing.JLabel lblInformer;
    private javax.swing.JList lstContracts;
    private javax.swing.JList lstFilledContracts;
    private javax.swing.JList lstJobSkills;
    private javax.swing.JList lstMatches;
    private javax.swing.JPanel pnlArrangements;
    private javax.swing.JPanel pnlContracts;
    private javax.swing.JPanel pnlLogin;
    private javax.swing.JPanel pnlPlacement;
    private javax.swing.JTabbedPane tbdMain;
    private javax.swing.JTextArea txtContractSkills;
    private javax.swing.JTextArea txtEmployeeSkills;
    private javax.swing.JTextField txtJobSkill;
    private javax.swing.JPasswordField txtPwd;
    // End of variables declaration//GEN-END:variables
}

