/*
 * getID.java
 *
 * Created on February 27, 2007, 10:54 AM
 *
 * By: Chace L. Prochazka
 */

package javaapplication3;
import java.awt.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;


public class getID extends javax.swing.JFrame {
    String theType = "";
    
 public Vector GetClients() {
        Vector companyNames = new Vector();
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            
            String sql = "SELECT ID, CompanyName FROM Company";
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    companyNames.addElement(rs.getObject(1) + " - " + rs.getObject(2));
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return companyNames;
        
}
 
  public Vector GetStaff() {
        Vector staffNames = new Vector();
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            
            String sql = "SELECT ID, LastName FROM Employee";
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    staffNames.addElement(rs.getObject(1) + " - " + rs.getObject(2));
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return staffNames;
        
}
  
   public Vector GetContracts() {
        Vector contractNames = new Vector();
 
        try
        {
            //  Connect to the Database

            String driver = "sun.jdbc.odbc.JdbcOdbcDriver";
            String url = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=C:/GCConcepts.mdb";
            String userid = "";
            String password = "";
 
            Class.forName( driver );
            Connection connection = DriverManager.getConnection( url, userid, password );
 
            //  Read data from a table
            
            String sql = "SELECT Contracts.ID, Company.CompanyName FROM Contracts, Company WHERE Contracts.compID = Company.ID";
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
 
            //  Get row data
            while (rs.next()) {
                    contractNames.addElement(rs.getObject(1) + " - " + rs.getObject(2));
            }
            
            rs.close();
            stmt.close();
        }
        catch(Exception e)
        {
            //System.out.println( e );
        }
        
        return contractNames;
        
}
    
    /** Creates new form getID */
    public getID(String type) {
        initComponents();
        setLocationRelativeTo(null);
        
        if (type.equalsIgnoreCase("contract") == true) {
            DefaultComboBoxModel model = new DefaultComboBoxModel(GetContracts());
            cboList.setModel(model); 
            theType = "contract";
        } else if (type.equalsIgnoreCase("staff") == true) {
            DefaultComboBoxModel model = new DefaultComboBoxModel(GetStaff());
            cboList.setModel(model); 
            theType = "staff";
        } else if (type.equalsIgnoreCase("client") == true) {
            DefaultComboBoxModel model = new DefaultComboBoxModel(GetClients());
            cboList.setModel(model); 
            theType = "client";
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        btnModify = new javax.swing.JButton();
        cboList = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        btnModify.setText("Modify");
        btnModify.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnModifyMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(36, 36, 36)
                .add(btnModify, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 79, Short.MAX_VALUE)
                .add(33, 33, 33))
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(cboList, 0, 128, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(8, 8, 8)
                .add(cboList, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnModify)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnModifyMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnModifyMouseClicked
        String someText = cboList.getSelectedItem().toString();
        int spot = someText.indexOf("-");
        String newText = someText.substring(0,(spot-1));
        int theID = Integer.valueOf(newText);
        
        if (theType == "client") {
            new modifyClient(theID).setVisible(true);
            this.dispose();
        } else if (theType == "contract") {
            new modifyContract(theID).setVisible(true);
            this.dispose();
        } else if (theType == "staff") {
            new modifyStaff(theID).setVisible(true);
            this.dispose();
        }
    }//GEN-LAST:event_btnModifyMouseClicked
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {

            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnModify;
    private javax.swing.JComboBox cboList;
    // End of variables declaration//GEN-END:variables
    
}
